<?
  // VStarBlogEngine - sync_status.php
  // (C) 2008-2012 Vladislav Staroselskiy (inet@vladstar.com)

  require "init.inc";

  if (! defined('BLOG_LJ_ENABLE_CROSSPOST') || ! BLOG_LJ_ENABLE_CROSSPOST || ! $userljname || ! $userljpass) {
    die(BLOG_MESSAGE_LJ_CROSSPOST_DISABLED);
  } elseif (! $userid || $userstatus<BLOG_USERS_TABLE_USER_STATUS_REGULAR) {
    die(BLOG_MESSAGE_ACCESS_DENIED);
  } else {
    $table=isset($_REQUEST["table"])&&$_REQUEST["table"]?unescape(urldecode($_REQUEST["table"])):false;
    $action=isset($_REQUEST["action"])&&$_REQUEST["action"]?unescape(urldecode($_REQUEST["action"])):false;
    $orderby=isset($_REQUEST["orderby"])&&$_REQUEST["orderby"]?unescape(urldecode($_REQUEST["orderby"])):false;
    $id=isset($_REQUEST["id"])&&is_numeric($_REQUEST["id"])&&$_REQUEST["id"]>0?$_REQUEST["id"]:false;
    $page=isset($_REQUEST["page"])&&is_numeric($_REQUEST["page"])&&$_REQUEST["page"]>=0?$_REQUEST["page"]:0;
    $reverse=isset($_REQUEST["reverse"])&&is_numeric($_REQUEST["reverse"])&&$_REQUEST["reverse"]>0?$_REQUEST["reverse"]:false;
    $content="";

    // Construct dependencies between tables
    $linked=array();
    $linked[BLOG_POSTS_TABLE][BLOG_POSTS_TABLE_USER_ID]=array(BLOG_USERS_TABLE,BLOG_USERS_TABLE_ID,"CONCAT(".BLOG_USERS_TABLE_NAME.",' (',".BLOG_USERS_TABLE_LOGIN.",')')","Name");
    $linked[BLOG_COMMENTS_TABLE][BLOG_COMMENTS_TABLE_POST_ID]=array(BLOG_POSTS_TABLE,BLOG_POSTS_TABLE_ID,"CONCAT(".BLOG_POSTS_TABLE_DATETIME.",' ',".BLOG_POSTS_TABLE_TITLE.",' (',".BLOG_POSTS_TABLE_ID.",') ')","Post");
  // $linked[BLOG_COMMENTS_TABLE][BLOG_COMMENTS_TABLE_PARENT_ID]=array(BLOG_COMMENTS_TABLE,BLOG_COMMENTS_TABLE_ID,"CONCAT(".BLOG_COMMENTS_TABLE_DATETIME.",' ',".BLOG_COMMENTS_TABLE_AUTHOR.",' (',".BLOG_COMMENTS_TABLE_EMAIL.",')')","ParentComment");

    if ($_SERVER["REQUEST_METHOD"]=="POST" && isset($_POST["action"]) && ($_POST["action"]==BLOG_LJ_SYNC_ACTION_CANCEL)) {
      header("location: sync_status.php");
    } elseif ($_SERVER["REQUEST_METHOD"]=="POST" && isset($_POST["action"]) && ($_POST["action"]==BLOG_LJ_SYNC_ACTION_NEXT || $_POST["action"]==BLOG_LJ_SYNC_ACTION_FINISH) && isset($_POST["A"]) && count($_POST["A"])) {
      print_flush(BLOG_LJ_SYNC_PROCESSING_1." ".count($_POST["A"])." ".BLOG_LJ_SYNC_PROCESSING_2);
      foreach($_POST["A"] as $value) {
        list($act,$lj_post_id)=preg_split("/_/",$value);
        if ($act=="a" && $lj_post_id && get_value(" SELECT ".BLOG_LJ_SYNC_POSTS_TABLE_ID." FROM ".BLOG_LJ_SYNC_POSTS_TABLE." WHERE ".BLOG_LJ_SYNC_POSTS_TABLE_ID."='".$lj_post_id."'") && ! get_value(" SELECT ".BLOG_POSTS_TABLE_ID." FROM ".BLOG_POSTS_TABLE." WHERE ".BLOG_POSTS_TABLE_USER_ID."='".$userid."' AND ".BLOG_POSTS_TABLE_LJ."='".$lj_post_id."'")) { 
          // Add to blog
          $blog->query("INSERT INTO ".BLOG_POSTS_TABLE." (".BLOG_POSTS_TABLE_USER_ID.",".BLOG_POSTS_TABLE_DATETIME.",".BLOG_POSTS_TABLE_TITLE.",".BLOG_POSTS_TABLE_CONTENT.",".BLOG_POSTS_TABLE_POST_STATUS.",".BLOG_POSTS_TABLE_COMMENT_STATUS.",".BLOG_POSTS_TABLE_SUBSCRIBE.",".BLOG_POSTS_TABLE_LJ.",".BLOG_POSTS_TABLE_LJ_URL.") (SELECT '".$userid."',".BLOG_LJ_SYNC_POSTS_TABLE_DATETIME.",".BLOG_LJ_SYNC_POSTS_TABLE_TITLE.",".BLOG_LJ_SYNC_POSTS_TABLE_CONTENT.",IF(".BLOG_LJ_SYNC_POSTS_TABLE_SECURITY."='".BLOG_LJ_SYNC_SECURITY_PRIVATE."','".BLOG_POSTS_TABLE_POST_STATUS_PRIVATE."',IF(".BLOG_LJ_SYNC_POSTS_TABLE_SECURITY."='".BLOG_LJ_SYNC_SECURITY_FRIENDSONLY."',".BLOG_POSTS_TABLE_POST_STATUS_FRIENDS.",".BLOG_POSTS_TABLE_POST_STATUS_PUBLIC.")),'".BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN."','".BLOG_POSTS_TABLE_SUBSCRIBE_NO."','".$lj_post_id."',".BLOG_LJ_SYNC_POSTS_TABLE_URL." FROM ".BLOG_LJ_SYNC_POSTS_TABLE." WHERE ".BLOG_LJ_SYNC_POSTS_TABLE_ID."='".$lj_post_id."' LIMIT 1)");
          $post_id=$blog->insert_id();
          if ($tags=trim(get_value("SELECT ".BLOG_LJ_SYNC_POSTS_TABLE_TAGS." FROM ".BLOG_LJ_SYNC_POSTS_TABLE." WHERE ".BLOG_LJ_SYNC_POSTS_TABLE_ID."='".$lj_post_id."'"))) SaveTags($post_id,explode(",",$tags));
          $blog->query("UPDATE ".BLOG_LJ_SYNC_POSTS_TABLE." SET ".BLOG_LJ_SYNC_POSTS_TABLE_POST_ID."='".$post_id."' WHERE ".BLOG_LJ_SYNC_POSTS_TABLE_ID."='".$lj_post_id."' LIMIT 1");
        } elseif ($act=="d" && $lj_post_id && get_value(" SELECT ".BLOG_LJ_SYNC_POSTS_TABLE_ID." FROM ".BLOG_LJ_SYNC_POSTS_TABLE." WHERE ".BLOG_LJ_SYNC_POSTS_TABLE_ID."='".$lj_post_id."'") && ! get_value(" SELECT ".BLOG_POSTS_TABLE_ID." FROM ".BLOG_POSTS_TABLE." WHERE ".BLOG_POSTS_TABLE_USER_ID."='".$userid."' AND ".BLOG_POSTS_TABLE_LJ."='".$lj_post_id."'")) { 
          // Delete from LJ
          list($headers,$lines,$retvalues)=LJUpdate($userljname, $userljpass, $userljjournal, BLOG_LJ_JOURNAL, $lj_post_id ,'', '');
          $blog->query("DELETE FROM ".BLOG_LJ_SYNC_POSTS_TABLE." WHERE ".BLOG_LJ_SYNC_POSTS_TABLE_POST_ID."='".$lj_post_id."' LIMIT 1");
        } elseif ($act=="b" && $lj_post_id && get_value(" SELECT ".BLOG_LJ_SYNC_POSTS_TABLE_ID." FROM ".BLOG_LJ_SYNC_POSTS_TABLE." WHERE ".BLOG_LJ_SYNC_POSTS_TABLE_ID."='".$lj_post_id."'")) { 
          // Update blog
          $post_id=get_value("SELECT ".BLOG_LJ_SYNC_POSTS_TABLE_POST_ID." FROM ".BLOG_LJ_SYNC_POSTS_TABLE." WHERE ".BLOG_LJ_SYNC_POSTS_TABLE_ID."='".$lj_post_id."'");
          $blog->query("UPDATE ".BLOG_POSTS_TABLE.",".BLOG_LJ_SYNC_POSTS_TABLE." SET ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_DATETIME."=".BLOG_LJ_SYNC_POSTS_TABLE.".".BLOG_LJ_SYNC_POSTS_TABLE_DATETIME.",".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_TITLE."=".BLOG_LJ_SYNC_POSTS_TABLE.".".BLOG_LJ_SYNC_POSTS_TABLE_TITLE.",".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_CONTENT."=".BLOG_LJ_SYNC_POSTS_TABLE.".".BLOG_LJ_SYNC_POSTS_TABLE_CONTENT.",".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_POST_STATUS."=IF(".BLOG_LJ_SYNC_POSTS_TABLE_SECURITY."='".BLOG_LJ_SYNC_SECURITY_PRIVATE."','".BLOG_POSTS_TABLE_POST_STATUS_PRIVATE."',IF(".BLOG_LJ_SYNC_POSTS_TABLE_SECURITY."='".BLOG_LJ_SYNC_SECURITY_FRIENDSONLY."',".BLOG_POSTS_TABLE_POST_STATUS_FRIENDS.",".BLOG_POSTS_TABLE_POST_STATUS_PUBLIC.")),".BLOG_POSTS_TABLE_COMMENT_STATUS."='".BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN."',".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_SUBSCRIBE."='".BLOG_POSTS_TABLE_SUBSCRIBE_NO."',".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_LJ."='".$lj_post_id."',".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_LJ_URL."=".BLOG_LJ_SYNC_POSTS_TABLE.".".BLOG_LJ_SYNC_POSTS_TABLE_URL." WHERE ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_USER_ID."='".$userid."' AND ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID."=".BLOG_LJ_SYNC_POSTS_TABLE.".".BLOG_LJ_SYNC_POSTS_TABLE_POST_ID." AND ".BLOG_LJ_SYNC_POSTS_TABLE.".".BLOG_LJ_SYNC_POSTS_TABLE_ID."='".$lj_post_id."'");
          if ($tags=trim(get_value("SELECT ".BLOG_LJ_SYNC_POSTS_TABLE_TAGS." FROM ".BLOG_LJ_SYNC_POSTS_TABLE." WHERE ".BLOG_LJ_SYNC_POSTS_TABLE_ID."='".$lj_post_id."'"))) SaveTags($post_id,explode(",",$tags));
        } elseif ($act=="l" && $lj_post_id && get_value(" SELECT ".BLOG_LJ_SYNC_POSTS_TABLE_ID." FROM ".BLOG_LJ_SYNC_POSTS_TABLE." WHERE ".BLOG_LJ_SYNC_POSTS_TABLE_ID."='".$lj_post_id."'") && get_value(" SELECT ".BLOG_POSTS_TABLE_ID." FROM ".BLOG_POSTS_TABLE." WHERE ".BLOG_POSTS_TABLE_USER_ID."='".$userid."' AND ".BLOG_POSTS_TABLE_LJ."='".$lj_post_id."'")) { 
          // Update LJ
          $post_id=get_value("SELECT ".BLOG_LJ_SYNC_POSTS_TABLE_POST_ID." FROM ".BLOG_LJ_SYNC_POSTS_TABLE." WHERE ".BLOG_LJ_SYNC_POSTS_TABLE_ID."='".$lj_post_id."'");
          $blog->query("SELECT * FROM ".BLOG_POSTS_TABLE." WHERE ".BLOG_POSTS_TABLE_USER_ID."='".$userid."' AND ".BLOG_POSTS_TABLE_ID."='".$post_id."' LIMIT 1");
          if ($blog->num_rows()) {
            $blog->next_record();
            $msg_tail="<p align=\"right\"><b><a href=\"http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"])."/?post=".$id."\" align=\"right\" class=\"comments\"><img src=\"http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"])."/comments.php?post=".$post_id."\" border=0 width=8 height=12>".BLOG_LJ_COMMENTS."</a></b>|<a href=\"http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"])."/?post=".$post_id."#reply\">".BLOG_LJ_LEAVE_COMMENT."</a></p>";
            $tags=implode(", ",GetTags($post_id));
            list($headers,$lines,$retvalues)=LJUpdate($userljname, $userljpass, $userljjournal, $lj_post_id, stripslashes($blog->f(BLOG_POSTS_TABLE_TITLE)), (strpos(stripslashes($blog->f(BLOG_POSTS_TABLE_CONTENT)),'<!--more-->')!==false?str_replace('<!--more-->','<lj-cut text="'.BLOG_MORE.'">',stripslashes($blog->f(BLOG_POSTS_TABLE_CONTENT)).'</lj-cut>'):stripslashes($blog->f(BLOG_POSTS_TABLE_CONTENT)).$msg_tail), ($blog->f(BLOG_POSTS_TABLE_POST_STATUS)==BLOG_POSTS_TABLE_POST_STATUS_PRIVATE?"private":($blog->f(BLOG_POSTS_TABLE_POST_STATUS)==BLOG_POSTS_TABLE_POST_STATUS_FRIENDS?"usemask":"public")), $tags, ($blog->f(BLOG_POSTS_TABLE_COMMENT_STATUS)?1:0), $blog->f(BLOG_POSTS_TABLE_DATETIME));
          }
        }
        usleep(BLOG_LJ_SYNC_SLEEP);
        print_flush(" .");
      }
      print_flush(BLOG_LJ_SYNC_PROCESS_DONE."<br>\n");
    } elseif ($_SERVER["REQUEST_METHOD"]=="POST" && isset($_POST["action"]) && $_POST["action"]==BLOG_LJ_SYNC_ACTION_SYNC) {
      if (count($_POST["I"])) {
        for ($r=0; $r<count($_POST["I"]); $r++){
          $index=$_POST["I"][$r];
          $blog->query("SELECT * FROM ".BLOG_POSTS_TABLE." LEFT JOIN ".BLOG_LJ_SYNC_POSTS_TABLE." ON ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID."=".BLOG_LJ_SYNC_POSTS_TABLE.".".BLOG_LJ_SYNC_POSTS_TABLE_POST_ID." WHERE ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_USER_ID."='".$userid."' AND ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID."='".$index."' AND ".BLOG_LJ_SYNC_POSTS_TABLE.".".BLOG_LJ_SYNC_POSTS_TABLE_ID." IS NULL LIMIT 1");
          if ($blog->num_rows()) {
            $blog->next_record();
            $post_id=$blog->f(BLOG_POSTS_TABLE_ID);
            print_flush(BLOG_LJ_SYNC_BLOG2LJ_ADD."<a href=\"http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"])."/?post=".$post_id."\" target=_blank>".$post_id."</a>... ");
            $msg_tail="<p align=\"right\"><b><a href=\"http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"])."/?post=".$post_id."\" align=\"right\" class=\"comments\"><img src=\"http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"])."/comments.php?post=".$post_id."\" border=0 width=8 height=12>".BLOG_LJ_COMMENTS."</a></b>|<a href=\"http://".$_SERVER["SERVER_NAME"].dirname($_SERVER["SCRIPT_NAME"])."/?post=".$post_id."#reply\">".BLOG_LJ_LEAVE_COMMENT."</a></p>";
            $tags=implode(", ",GetTags($post_id));
            list($headers,$lines,$retvalues)=LJAdd($userljname, $userljpass, $userljjournal, stripslashes($blog->f(BLOG_POSTS_TABLE_TITLE)), (strpos(stripslashes($blog->f(BLOG_POSTS_TABLE_CONTENT)),'<!--more-->')!==false?str_replace('<!--more-->','<lj-cut text="'.BLOG_MORE.'">',stripslashes($blog->f(BLOG_POSTS_TABLE_CONTENT)).'</lj-cut>'):stripslashes($blog->f(BLOG_POSTS_TABLE_CONTENT)).$msg_tail), ($blog->f(BLOG_POSTS_TABLE_POST_STATUS)==BLOG_POSTS_TABLE_POST_STATUS_PRIVATE?"private":($blog->f(BLOG_POSTS_TABLE_POST_STATUS)==BLOG_POSTS_TABLE_POST_STATUS_PRIVATE?"usemask":"public")), $tags, $blog->f(BLOG_POSTS_TABLE_COMMENT_STATUS)==BLOG_POSTS_TABLE_COMMENT_STATUS_OPEN?1:0, $blog->f(BLOG_POSTS_TABLE_DATETIME), true);
            if (isset($retvalues["success"]) && $retvalues["success"]=="OK") {
              $blog1->query("UPDATE ".BLOG_POSTS_TABLE." SET ".BLOG_POSTS_TABLE_LJ."='".addslashes($retvalues["itemid"])."',".BLOG_POSTS_TABLE_LJ_URL."='".addslashes($retvalues["url"])."' WHERE ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_USER_ID."='".$userid."' AND ".BLOG_POSTS_TABLE_ID."='".$post_id."' LIMIT 1");
              print_flush(BLOG_LJ_SYNC_DONE.", ".BLOG_LJ_SYNC_BLOG2LJ_NEW_LJ_RECORD."<a href=\"".$retvalues["url"]."\" target=_blank>".$retvalues["itemid"]."</a><br>\n");
            } else {
              print_flush(BLOG_LJ_SYNC_BLOG2LJ_FAILED."<br>\n");
            }
          }
        }
      }
    }
    if ($_SERVER["REQUEST_METHOD"]=="POST" && isset($_POST["cache"]) && $_POST["cache"]=="1") {
      $blog->query("TRUNCATE TABLE ".BLOG_LJ_SYNC_POSTS_TABLE);
      $syncdate="1970-01-01 ".date("H:i:s");
    } else {
      $lastdate=get_value(" SELECT ".BLOG_LJ_SYNC_POSTS_TABLE_DATETIME." FROM ".BLOG_LJ_SYNC_POSTS_TABLE." ORDER BY ".BLOG_LJ_SYNC_POSTS_TABLE_DATETIME." DESC LIMIT 1");
      $syncdate=isset($_REQUEST["syncdate"])?unescape(urldecode($_REQUEST["syncdate"])):($lastdate?$lastdate:"1970-01-01 ".date("H:i:s"));
    }
    if (isset($retvalues["errmsg"]) && isset($retvalues["success"]) && $retvalues["success"]=="FAIL") {
      $message.=BLOG_LJ_ERROR." \"".$retvalues["errmsg"]."\"";
    }

    $retform="<form method=\"post\">\n";
    if (isset($messageok) && $messageok) print_flush("<p class=\"messageok\">".$messageok."</p>\n");
    if (isset($message) && $message) print_flush("<p class=\"message\">".$message."</p>\n");
    $events=array();
    if (isset($_POST["action"])  && $_POST["action"]==BLOG_LJ_SYNC_ACTION_FINISH) {
      $blog->query("SELECT * FROM ".BLOG_POSTS_TABLE." LEFT JOIN ".BLOG_LJ_SYNC_POSTS_TABLE." ON ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_ID."=".BLOG_LJ_SYNC_POSTS_TABLE.".".BLOG_LJ_SYNC_POSTS_TABLE_POST_ID." WHERE ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_USER_ID."='".$userid."' AND ".BLOG_LJ_SYNC_POSTS_TABLE.".".BLOG_LJ_SYNC_POSTS_TABLE_ID." IS NULL");
      if ($blog->num_rows()) {
        print_flush(BLOG_LJ_SYNC_BLOG2LJ_NOTICE); 
        $retform.="<p align=\"center\"><input type=\"submit\" name=\"action\" value=\"".BLOG_LJ_SYNC_ACTION_SYNC."\">  &nbsp; <input type=\"submit\" name=\"action\" value=\"".BLOG_LJ_SYNC_ACTION_CANCEL."\"></p>\n";
        $retform.="<table border=1 class=\"blog_admin\"><tr class=\"blog_admin\"><th class=\"blog_admin\">".(isset($FieldNames["Post_ID"])?$FieldNames["Post_ID"]:"Post ID")."</th><th class=\"blog_admin\">".(isset($FieldNames["CreatedOn"])?$FieldNames["CreatedOn"]:"Event Time")."</th><th class=\"blog_admin\">".(isset($FieldNames["Title"])?$FieldNames["Title"]:"Title")."</th><th class=\"blog_admin\">".(isset($FieldNames["Add"])?$FieldNames["Add"]:"Add")."</th></tr>\n";
        while ($blog->next_record()) {
          print_flush(" .");
          $retform.="<tr class=\"blog_admin\"><td class=\"blog_admin\"><a href=\"./?post=".$blog->f(BLOG_POSTS_TABLE_ID)."\" target=_blank>".$blog->f(BLOG_POSTS_TABLE_ID)."</a></td><td>".$blog->f(BLOG_POSTS_TABLE_DATETIME)."</td><td>".$blog->f(BLOG_POSTS_TABLE_TITLE)."</td><td class=\"data\"><input type=\"checkbox\" name=\"I[]\" value=\"".$blog->f(BLOG_POSTS_TABLE_ID)."\"></td></tr>\n";
        }
        $retform.="</table>\n<p align=\"center\"><input type=\"submit\" name=\"action\" value=\"".BLOG_LJ_SYNC_ACTION_SYNC."\">  &nbsp; <input type=\"submit\" name=\"action\" value=\"".BLOG_LJ_SYNC_ACTION_CANCEL."\"></p>\n";
      } else {
        print_flush("<p>".BLOG_LJ_SYNC_DONE."</p>");
      }
    } elseif ($_SERVER["REQUEST_METHOD"]=="POST" && isset($_POST["action"]) && ($_POST["action"]==BLOG_LJ_SYNC_ACTION_START || $_POST["action"]==BLOG_LJ_SYNC_ACTION_NEXT)) {
      print_flush(BLOG_LJ_SYNC_FETCHING_DATA);
      list($headers,$lines,$retvalues)=LJGetItems($userljname, $userljpass, $userljjournal, "syncitems", 1, false, $syncdate, 0);
      print_flush(BLOG_LJ_SYNC_DONE."<br>\n");
      print_flush(BLOG_LJ_SYNC_PARSING_DATA);
      preg_match_all('/^events_(\d+)_anum\n(.*?)\nevents_\\1_event\n(.*?)\nevents_\\1_eventtime\n(.*?)\nevents_\\1_itemid\n(.*?)\n(?:(?:events_\\1_security\n)(.*?)\n)*(?:events_\\1_subject\n(.*?)\n)*events_\\1_url\n(.*?)\n/usm',$lines,$matches,PREG_SET_ORDER);
      foreach ($matches as $value) {
        $events[$value[5]]["eventtime"]=$value[4];
        $events[$value[5]]["subject"]=$value[7];
        $events[$value[5]]["security"]=$value[6];
        $events[$value[5]]["event"]=$value[3];
        $events[$value[5]]["url"]=$value[8];
      }
      ksort($events);
      preg_match('/^events_count\n(.*?)\n/usm',$lines,$matches);
      $events_count=$matches[1];
      preg_match_all('/^prop_(\d+)_itemid\n(.*?)\nprop_\\1_name\n(taglist)\nprop_\\1_value\n(.*?)\n/usm',$lines,$matches,PREG_SET_ORDER);
      foreach ($matches as $value) {
        $tags[$value[2]]=$value[4];
        $events[$value[2]]["taglist"]=$value[4];
      }
      print_flush(BLOG_LJ_SYNC_DONE.", ".BLOG_LJ_SYNC_FOUND." ".count($events)." ".BLOG_LJ_SYNC_RECORDS."<br>\n");
      print_flush(BLOG_LJ_SYNC_MATCHING_DATA);
      if (count($events)) {
        $retform.="<p align=\"center\"><input type=\"submit\" name=\"action\" value=\"".($events_count==100?BLOG_LJ_SYNC_ACTION_NEXT:BLOG_LJ_SYNC_ACTION_FINISH)."\"> &nbsp; <input type=\"submit\" name=\"action\" value=\"".BLOG_LJ_SYNC_ACTION_CANCEL."\"></p>\n";
        $retform.="<table border=1 class=\"blog_admin\"><tr class=\"blog_admin\"><th class=\"blog_admin\" width=\"20\">".(isset($FieldNames["LJ_ID"])?$FieldNames["LJ_ID"]:"LJ ID")."</th><th class=\"blog_admin\"  width=\"20\">".(isset($FieldNames["Post_ID"])?$FieldNames["Post_ID"]:"Post ID")."</th><th class=\"blog_admin\" width=\"150\">".(isset($FieldNames["CreatedOn"])?$FieldNames["CreatedOn"]:"Event Time")."</th><th class=\"blog_admin\">".(isset($FieldNames["Title"])?$FieldNames["Title"]:"Title")."</th><th class=\"blog_admin\">".(isset($FieldNames["Difference"])?$FieldNames["Difference"]:"Difference")."</th><th class=\"blog_admin\">".(isset($FieldNames["Action"])?$FieldNames["Action"]:"Action")."</th></tr>\n";


        mb_internal_encoding("UTF-8");
        mb_regex_encoding("UTF-8");
        $in=array("&#8230;","&#8217;","&#8220;","&#8221;","&#8243;","&nbsp;");
        $out=array("...","'","\"","\"","\""," ");
        foreach ($events as $key=>$value) {
          for ($i=0; $i<sizeof($in); $i++) { 
            $value["subject"] = mb_ereg_replace($in[$i], $out[$i], $value["subject"]); 
            $value["event"] = mb_ereg_replace($in[$i], $out[$i], $value["event"]); 
          } 
          $value["event"]=preg_replace(array('/<p align="right"><b><a href="http:'.'\/\/'.$_SERVER["SERVER_NAME"].'.*?<\/p>/usm','/<lj-cut.*?>/usm','/<\/lj-cut>/usm','/<lj user="(.*?)".*?>/usm'),array('','<!--more-->','',' <a href="http://\1.livejournal.com/">\1</a> '),$value["event"]);
          $value["taglist"]=(isset($value["taglist"])?$value["taglist"]:"");
          $blog->query("SELECT * FROM ".BLOG_POSTS_TABLE." WHERE ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_USER_ID."='".$userid."' AND ".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_TITLE."='".addslashes($value["subject"])."' AND ABS(DATEDIFF(".BLOG_POSTS_TABLE.".".BLOG_POSTS_TABLE_DATETIME.",'".$value["eventtime"]."'))=0");
          $diff="";
          $todo="&nbsp;";
          if ($blog->num_rows()) {
            $blog->next_record();
            $post_id=$blog->f(BLOG_POSTS_TABLE_ID);
            $content=preg_replace(array('/<!--more-->/usm','/\r\n/usm'),array('',"\n"),$blog->f(BLOG_POSTS_TABLE_CONTENT));
            $title=$blog->f(BLOG_POSTS_TABLE_TITLE);
            $datetime=$blog->f(BLOG_POSTS_TABLE_DATETIME);
            $lj_post_id=$blog->f(BLOG_POSTS_TABLE_LJ);
            $lj_post_url=$blog->f(BLOG_POSTS_TABLE_LJ_URL);
            $poststatus=$blog->f(BLOG_POSTS_TABLE_POST_STATUS);
            $tags=GetTags($post_id);
            if (substr($datetime,0,16)!=substr($value["eventtime"],0,16)) $diff.=($diff?", ":"")."date/time";
            if ($title!=$value["subject"]) $diff.=($diff?", ":"").BLOG_LJ_SYNC_DIFF_TITLE;
            // Tags comparison will require UTF-8 first char upper conversion, which may be implemented later
            // if (count($tags)!=count(explode(",",$value["taglist"])) || array_diff($tags,explode(", ",$value["taglist"]))) $diff.=($diff?", ":"")."tags";
            if ($value["security"] && (($value["security"]=="usemask" && $poststatus!=BLOG_POSTS_TABLE_POST_STATUS_FRIENDS) || ($value["security"]=="private" && $poststatus!=BLOG_POSTS_TABLE_POST_STATUS_PRIVATE)) ) $diff.=($diff?", ":"").BLOG_LJ_SYNC_DIFF_POST_STATUS;
            if ($lj_post_id!=$key) $diff.=($diff?", ":"").BLOG_LJ_SYNC_DIFF_LJ_ID;
            if ($lj_post_url!=$value["url"]) $diff.=($diff?", ":"").BLOG_LJ_SYNC_DIFF_LJ_URL;
            if (str_replace(array(BLOG_LJ_COMMENTS,BLOG_LJ_LEAVE_COMMENT,"|","\n","\r"," "),'',strip_tags($content))!=str_replace(array(BLOG_LJ_COMMENTS,BLOG_LJ_LEAVE_COMMENT,"|","\n","\r"," "),'',strip_tags($value["event"]))) {
              $diff.=($diff?", ":"").BLOG_LJ_SYNC_DIFF_CONTENT;
            }
            if ($diff) {
              $todo="<select name=\"A[]\"><option value=\"b_".$key."\">".BLOG_LJ_SYNC_ACTION_UPDATE_BLOG."</option><option value=\"l_".$key."\">".BLOG_LJ_SYNC_ACTION_UPDATE_LJ."</option><option value=\"\">".BLOG_LJ_SYNC_ACTION_NONE."</option selected></select>";
            } else {
              $diff=BLOG_LJ_SYNC_ACTION_NONE;
            }
          } else {
            $post_id=false;
            $diff=BLOG_LJ_SYNC_DIFF_MISSING;
            $todo="<select name=\"A[]\"><option value=\"a_".$key."\" selected>".BLOG_LJ_SYNC_ACTION_ADD_TO_BLOG."</option><option value=\"d_".$key."\">".BLOG_LJ_SYNC_ACTION_DELETE_FROM_LJ."</option><option value=\"\">".BLOG_LJ_SYNC_ACTION_NONE."</option></select>";
          }
          $retform.="<tr><td><a href=\"".$value["url"]."\" target=_blank>".$key."</a></td><td>".($post_id?"<a href=\"./?post=".$post_id."\" target=_blank>".$post_id."</a>":"&nbsp;")."</td><td>".$value["eventtime"]."</td><td>".$value["subject"]."</td><td>".$diff."</td><td>".$todo."</td></tr>\n";
          if (get_value("SELECT ".BLOG_LJ_SYNC_POSTS_TABLE_ID." FROM ".BLOG_LJ_SYNC_POSTS_TABLE." WHERE ".BLOG_LJ_SYNC_POSTS_TABLE_ID."='".$key."'")) {
            $query="UPDATE ".BLOG_LJ_SYNC_POSTS_TABLE." SET ".BLOG_LJ_SYNC_POSTS_TABLE_POST_ID."='".$post_id."',".BLOG_LJ_SYNC_POSTS_TABLE_DATETIME."='".$value["eventtime"]."',".BLOG_LJ_SYNC_POSTS_TABLE_TITLE."='".addslashes($value["subject"])."',".BLOG_LJ_SYNC_POSTS_TABLE_CONTENT."='".addslashes($value["event"])."',".BLOG_LJ_SYNC_POSTS_TABLE_TAGS."='".addslashes($value["taglist"])."',".BLOG_LJ_SYNC_POSTS_TABLE_SECURITY."='".addslashes($value["security"])."',".BLOG_LJ_SYNC_POSTS_TABLE_URL."='".addslashes($value["url"])."' WHERE ".BLOG_LJ_SYNC_POSTS_TABLE_ID."='".$key."'";
          } else {
            $query="INSERT INTO ".BLOG_LJ_SYNC_POSTS_TABLE." (".BLOG_LJ_SYNC_POSTS_TABLE_ID.",".BLOG_LJ_SYNC_POSTS_TABLE_POST_ID.",".BLOG_LJ_SYNC_POSTS_TABLE_DATETIME.",".BLOG_LJ_SYNC_POSTS_TABLE_TITLE.",".BLOG_LJ_SYNC_POSTS_TABLE_CONTENT.",".BLOG_LJ_SYNC_POSTS_TABLE_TAGS.",".BLOG_LJ_SYNC_POSTS_TABLE_SECURITY.",".BLOG_LJ_SYNC_POSTS_TABLE_URL.") VALUES ('".$key."','".$post_id."','".$value["eventtime"]."','".addslashes($value["subject"])."','".addslashes($value["event"])."','".addslashes($value["taglist"])."','".addslashes($value["security"])."','".addslashes($value["url"])."')";
          }
          $blog1->query($query);
        }
        print_flush(BLOG_LJ_SYNC_DONE.", ".BLOG_LJ_SYNC_RESULTS."<br>\n");
        if ($events[$key]["eventtime"]) {
          $retform.="<caption>".$syncdate." - ".$events[$key]["eventtime"]."</caption>\n";
        }
        $retform.="</table>\n";
      } else {
         $retform.="<p align=\"center\">".BLOG_LJ_SYNC_NO_NEW_RECORDS."</p>";
      }
      $retform.="<input type=\"hidden\" name=\"syncdate\" value=\"".substr($events[$key]["eventtime"],0,14).date("i:s")."\">\n";
      $retform.="<p align=\"center\"><input type=\"submit\" name=\"action\" value=\"".($events_count==100?BLOG_LJ_SYNC_ACTION_NEXT:BLOG_LJ_SYNC_ACTION_FINISH)."\"> &nbsp; <input type=\"submit\" name=\"action\" value=\"".BLOG_LJ_SYNC_ACTION_CANCEL."\"></p>\n";
    } elseif ($_SERVER["REQUEST_METHOD"]=="POST" && isset($_POST["action"]) && $_POST["action"]==BLOG_LJ_SYNC_ACTION_SYNC) {
      $retform.="<p>".BLOG_LJ_SYNC_PROCESS_DONE."</p>";
    } else {
      $retform.="<p align=\"center\">".BLOG_LJ_SYNC_START_NOTICE."</p>\n";
      $retform.="<p align=\"center\">".BLOG_LJ_SYNC_START_COMPLETE." <input type=\"radio\" name=\"cache\" value=\"1\"> &nbsp; ".BLOG_LJ_SYNC_START_CONTINUE." <input type=\"radio\" name=\"cache\" value=\"0\" checked></p>\n";
      $retform.="<p align=\"center\"><input type=\"submit\" name=\"action\" value=\"".BLOG_LJ_SYNC_ACTION_START."\"> &nbsp; <input type=\"submit\" name=\"action\" value=\"".BLOG_LJ_SYNC_ACTION_CANCEL."\"></p>\n";
    }
    $retform.="</form>\n";
    print $retform;
  }
?>
